function D3 = funcD3e_fin(eco,q,B0,display,BG)

theta           = eco.theta;
sigma           = eco.sigma;     % log case
beta            = eco.beta;
lbar            = eco.lbar;      %labor supply when unproductive
alpha           = eco.alpha;      % 
rho             = eco.rho;      % Quarterly value 0.75
phi             = eco.phi;      % productivity scale when excluded
%BG              = eco.BG;


Uc              = eco.Uc;
Ucinv           = eco.Ucinv;
U               = eco.U;

l0              = Ucinv(1/phi)/phi;
Uv              = [U(phi*l0)-l0;U(phi*lbar)-lbar];
M               = [alpha, 1-alpha;1-rho,rho];                       
Wv              = inv(eye(2) - beta*M)*Uv;
We              = Wv(1);
Wu              = Wv(2);

nprod           = (1 - rho)/(2-alpha-rho);
np              = 1;
tax             = (q-1)*BG/np;


qa              = beta*(alpha + (1-alpha)*Uc(lbar));


c0              = Ucinv(1);
c1              = Ucinv((q./beta - alpha)./(1-alpha));
c2              = Ucinv( ( ((q./beta - alpha)./(1-alpha)).*q/beta - (1- rho))./rho);
B1              = B0/q - (c1-lbar + tax)/q;
B2              = (B1 - c2 + lbar - tax)/((1-rho)*q);



V20             = We;
V10             = We - B2 + B1;
V00             = We - B2 + B0;


V2              = U(c2) - lbar + beta*(rho*Wu +(1 - rho)*V20);
V1              = U(c1) - lbar + beta*(rho*V2 +(1 - rho)*V10);
V20b            = U(c0) - (c0 + tax - B2 + q*B0) + beta*(alpha*V00 + (1-alpha)*V1);

V3 = -10000;
if (lbar + B2 - (1-rho)*q*B2)>0
    V3              = U(lbar -tax + B2 - (1-rho)*q*B2) + beta*(rho*Wu +(1 - rho)*V20);
end;



FM              = B0 +(1-alpha)*B1 +rho*(1-alpha)*(1-rho)*B2 + BG/np;

Wtot        = (1-alpha)*np*V1 +(1-rho)*(1-alpha)*np*V10+ rho*(1-alpha)*np*V2 + (1-rho)*rho*(1-alpha)*np*V20...
                + rho*rho*(1-alpha)*np*(V00-B0) + np*(1 - (1-rho)*(1-alpha) - (1-rho)*rho*(1-alpha) - rho*rho*(1-alpha))*V00;

D3.qs       = q;
D3.B0       = B0;
D3.B1       = B1;
D3.B2       = B2;
D3.V00      = V00;
D3.V20      = V20;
D3.V20b     = V20b;
D3.We       = We;
D3.V1       = V1;
D3.V2       = V2;
D3.V3       = V3;
D3.Wu       = Wu;

D3.c0       = c0;
D3.c1       = c1;
D3.c2       = c2;
D3.FM       = FM;
D3.Wtot     = Wtot;


D3.exist = false;
 if B0>B2 && V2>Wu && V3<Wu
     D3.exist = true;
 end;


                                